;	 MAIN "Myth01",#40

;  	
Monitor RET
	 EX AF,AF'
	 EXX
	 LD A,(PageN)
	 PUSH AF
	 LD HL,(MonitorA)
	 LD A,(MonitorP)
	 CALL Page
	 POP AF
	 PUSH HL
	 EXX
	 EX AF,AF'
	 RET
MonitorA DW 0
MonitorP DB 0

; 
;In:AHL=  
;   B= 
ClearMem
	 LD L,A
	 LD A,H
	 LD H,L
	 PUSH BC
	 CALL Adr_Bl	 ;HL=
	 EX DE,HL
	 CALL MemBeg
	 ADD HL,DE
	 POP BC
ClearM0  LD (HL),0
	  INC HL
	  DJNZ ClearM0
	 RET

; 	
RestoreBuffer
	 LD A,7
	 CALL Page
	 LD HL,#C000
	 LD DE,#4000
	 CALL LDB
	 XOR A
	 JP Scr

;    
OpenBuffer
	 LD A,7
	 CALL Page
	 LD HL,#4000
	 LD DE,#C000
	 CALL LDB
	 LD A,8
	 JP Scr

;   
;    
;In:AHL=
;   BDE=
;     C= [1..255]
PToP
	 PUSH BC
	 PUSH DE
	 LD DE,DBuf ;
	 LD B,0
	 PUSH BC
	 CALL Moving;  
	 POP BC
	 POP DE
	 POP AF
	 LD HL,DBuf
;	 JP Moving
;    
;In:A=	
;   BC= 
;   HL=
;   DE=
Moving	 CALL Page
	 LDIR
	 RET

;    	 .
;In:B=    (1..64)
;   A=	
;   HL= 
;   DE= 
FastMove
	 CALL Page
	 LD C,0
	 JR LDB0

; 6912 . HL->DE
;115000 t=0.033sek
LDB	 LD BC,6912
   ;4256   256	
LDB0	 REP 32
	  LDI
	 ENDR
	 LD A,B
	 OR C
	 JR NZ,LDB0
	 RET
;IN: AHL - ..
;OUT:HL  - ..
;  
LogA	 CALL Page
	 LD A,H
	 OR #C0
	 LD H,A
	 RET
;IN: HL - ...
;OUT:AHL -..
Bl_Log	 PUSH HL
	 ADD HL,HL
	 ADD HL,HL
	 LD A,H
	 POP HL
	 LD H,L
	 RES 7,H
	 RES 6,H
	 LD L,0
	 RET

;   
;In:H=Pg,L=.
;Out:A= 
ReadA	 PUSH HL
	 CALL BlkAdr
	 LD A,(HL)
	 POP HL
	 RET
;   
;In:H=Pg,L=.,A= 
WriteA	 PUSH HL
	 CALL BlkAdr
	 LD (HL),A
	 POP HL
	 RET

;In:H=Pg,L= 
;Out:HL=     
;	    
BlkAdr
	 PUSH AF
	 LD A,L
	 CALL Adr_Bl
	 LD A,H
	 OR #C0
	 LD H,A
	 LD A,(MapPg)
	 CALL Page
	 POP AF
	 RET

;IN:H=Pg,A=HgByte
;OUT:HL=Block number
Adr_Bl	 LD L,0
	 SRA H
	 RR L
	 SRA H
	 RR L
	 AND #3F
	 OR L
	 LD L,A
	 RET

;	   ,
;    ,
;  
;Out:A= .,
;     =0, Out of	memory
FindBlk CALL MemBeg
	  LD A,(Mem);	
	 LD C,A

FB1	 LD B,64 ;  
FB0	  LD A,(HL)
	  INC HL
	  OR A
	  JR Z,FirstB ;  
	  DJNZ FB0 ; .
	 DEC C
	 JR NZ,FB1; .
	 XOR A	 ;Out of memory
	 RET
   ;  	 . 
FirstB	 LD C,0	 ;.
FB2	 INC C
	 LD A,(HL)
	 INC HL
	 OR A
	 JR NZ,EndB	 ;  
	 DJNZ FB2
    ;. 
EndB	 LD A,C
	 OR A	 ;"NZ"
	 RET


;   ,
;BC -  
;HL -  
MemBeg	 LD A,(MapPg)
	 CALL Page
	 LD A,(Mem)  ;
	 RRCA
	 RRCA
	 LD B,A
	 LD C,0	 ;BC - .
	 LD HL,#C000 ; 
	 RET
;	 
;HL- ,BC- 
;OUT: Z-  
;NZ- HL- .
FindF	 DEC BC
	 LD A,B
	 OR C
	 RET Z	 ;	
	 LD A,(HL)
	 INC HL
	 OR A
	 JR NZ,FindF
	 DEC HL
	 INC BC
	 DEC A
	 RET
;		
;HL- ,BC- 
;OUT:Z	-  	,DE-
;NZ- HL- .	,DE-
;DE -  
FindR	 LD E,L
	 LD D,H
FR0	 DEC BC
	 LD A,B
	 OR C
	 LD A,(HL)
	 INC HL
	 JR Z,FR1
	 OR A
	 JR Z,FR0
	 DEC HL
	 INC BC
FR1	 PUSH HL
	 SBC HL,DE
	 EX DE,HL
	 POP HL
	 OR A
	 RET
; . .
;  	(MaxFreeB)
MaxFree LD HL,0
	 LD (MaxFreeB),HL
	 CALL MemBeg
      ; 	
MF3	 CALL FindF
	 RET Z
	 CALL FindR
	 JR Z,MF2
	 PUSH HL
	 CALL MF2
	 POP HL
	 JR MF3
      ; 
MF2	 LD HL,(MaxFreeB)
	 SBC HL,DE
	 RET NC
	 LD (MaxFreeB),DE
	 RET

;    
;In:B=,A=
;Out:A=Page,NZ
;Z=Out	of mem
ResP	 LD yh,B	 ;Blk
	 PUSH AF
	 LD A,(Mem)
	 LD yl,A	 ;All Pg
	 CALL MemBeg
	 LD D,0		 ;Pg

RP1	 LD E,yh
	 PUSH HL
RP0	  LD A,(HL)
	  OR A
	  JR NZ,RNx	 ;Next Pg
	  DEC E
	  JR Z,ROk	 ;	
	  INC HL
	  JR RP0
RNx	 POP HL
	  PUSH DE
	  LD DE,64
	  ADD HL,DE
	  POP DE
	 INC D
	 DEC yl
	 JR NZ,RP1
	 POP AF
	 XOR A		 ;Z
	 RET
ROk	 POP HL
	 POP AF
R_	  LD (HL),A
	  INC HL
	  DEC yh
	  JR NZ,R_
	 LD A,H
	 OR A		 ;NZ
	 LD A,D
	 RET

; E      
;  A (1..#FE)
;NZ - OK ,HL - 
;Z  -   .
Reserv	 LD B,E
	 PUSH IX
	 PUSH IY
	 CALL ResPg
	 POP IY
	 POP IX
	 EX DE,HL
	 RET
; "B"   ""
;   
;Out:A=Page,H=. ,DE=	., "NZ"
;"Z"=Out of mem.
ResPg	 LD yh,B	 ;Blk
	 PUSH AF
	 LD A,(Mem)
	 LD yl,A	 ;All Pg
	 CALL MemBeg
	 LD D,0		 ;Pg

	 LD BC,64 ;    
	 ADD HL,BC

RP01	 LD E,yh
RP00	  DEC HL
	  LD A,(HL)
	  OR A
	  JR Z,RP02	 ; 
	   LD A,L
	   AND #3F
	   JR NZ,RP01
RP04	  INC D	 ; 
	  ADD HL,BC
	  ADD HL,BC
	  DEC yl
	  JR NZ,RP01
	 POP AF	 ;Out of mem.
	 XOR A
	 RET
RP02
	  DEC E
	  JR Z,RP03	 ;	
	  LD A,L
	 AND #3F
	 JR NZ,RP00
; 
	  JR RP04

;	   HL= ( ) 
RP03
	 POP AF
	 PUSH HL
;   ""
RP05	  LD (HL),A
	  INC HL
	  DEC yh
	  JR NZ,RP05
	 LD A,1
	 OR A	 ; "NZ"
	 LD A,D
	 POP DE
	 PUSH AF ;Page
	 RES 6,D
	 RES 7,D
	 LD A,E
	 OR #C0
	 LD H,A	 ;. 
	 POP AF	 ;Page
	 RET

; DE   
;  A (1..#FE)
;NZ - OK ,HL - 
;Z  -   .
ResDE	 EX AF,AF'
	 CALL MemBeg
	 LD (R2+1),HL
R2	 LD HL,0
	 CALL FindF
	 RET Z
	 PUSH HL
	 PUSH DE
	 CALL FindR
	 LD (R2+1),HL ;.	.
	 EX DE,HL
	 POP DE
	 JR Z,R0
	 SBC HL,DE
	 POP HL
	 JR C,R2
R3	 PUSH HL
R1	 EX AF,AF'
	 LD (HL),A
	 INC HL
	 DEC DE
	 EX AF,AF'
	 LD A,D
	 OR E
	 JR NZ,R1
	 POP HL
	 LD A,H
	 AND #3F
	 LD H,A
	 OR 1	    ;NZ
	 RET
R0	 SBC HL,DE
	 POP HL
	 JR NC,R3 ;
	 XOR A	  ;Z
	 RET
; "DE"  
;  . "yh",
; .
NextDE	 BIT 7,D
	 RET NZ	  ;OK
	 LD A,D
	 OR #C0
	 LD D,A
	 INC yh
	 LD A,yh
	 JP Page

; ,
; "A"
DelB	 LD D,A
	 CALL MemBeg
DB0	 LD A,D
	 CP (HL)
	 JR NZ,$+4
	  LD (HL),0
	 INC HL
	 DEC BC
	 LD A,B
	 OR C
	 JR NZ,DB0
	 RET
;  yl
PageY	 LD A,yl
	 JP Page


;------- ࠩ RAM-᪠ ---------------
;   ,
;  64 

;A-  (0,8)
Scr	 JR SCR0
Mem	 DB 8;  
;A-  
Page	 PUSH BC
	 PUSH AF
	 LD (PageN),A
	 AND 7
	 LD B,A
	 POP AF
	 AND #08 ;  
	 ADD A,A
	 ADD A,A
	 ADD A,A
	 OR B
	 LD B,A
	 LD A,(ScrN)
	 OR B
	 OR #10
	 LD BC,#7FFD
	 OUT (C),A

	 POP BC
	 RET
SCR0	 AND 8
	 LD (ScrN),A
	 LD A,(PageN)
	 JR Page
	 DS 22
EndDrv
;-------------------------------------------
;    254
; "A"
OkW	 LD D,A
	 CALL MemBeg
OW1	 LD A,(HL)
	 CP 254
	 JR NZ,$+3
	   LD (HL),D
	 INC HL
	 DEC BC
	 LD A,B
	 OR C
	 JR NZ,OW1
	 RET

;-----------------------------------------------
	;  

;	 , 
; 
;In:CHL= 
;Out:CHL= 
KosCHL
	 LD A,C
	 INC A
	 JR NZ,KosCHL0	 ; 
   ; #FF,  
	 LD A,(PageN)
	 LD C,A
KosCHL0
	 BIT 7,H
	 RET NZ
	 BIT 6,H
	 RET NZ
   ;  
	 LD A,H
	OR #C0
	 LD H,A
	 LD A,C
	 CALL Page
	 LD C,(HL)
	 INC HL
	 LD A,(HL)
	 INC HL
	 LD H,(HL)
	 LD L,A
	 JR KosCHL

;In:ADE= 
;Out:ADE= 
KosADE
	 CP #FF
	 JR NZ,KosADE0	 ; 
   ; #FF,  
	 LD A,(PageN)
KosADE0
	 BIT 7,D
	 RET NZ
	 BIT 6,D
	 RET NZ
	 PUSH AF
   ;  
	 EX DE,HL
	 LD A,H
	 OR #C0
	 LD H,A
	 POP AF
	 CALL Page
	 PUSH DE
	 LD A,(HL)
	 INC HL
	 LD E,(HL)
	 INC HL
	 LD D,(HL)
	 POP HL
	 JR KosADE

;In:ADE= 
;Out:ADE= 
KosAHL
	 CP #FF
	 JR NZ,KosAHL0	 ; 
   ; #FF,  
	 LD A,(PageN)
KosAHL0
	 BIT 7,H
	 RET NZ
	 BIT 6,H
	 RET NZ
	 PUSH AF
   ;  
	 LD A,H
	 OR #C0
	 LD H,A
	 POP AF
	 CALL Page
	 PUSH DE
	  LD A,(HL)
	  INC HL
	  LD E,(HL)
	  INC HL
	  LD D,(HL)
	  EX DE,HL
	 POP DE
	 JR KosAHL

;In:AIX= ; B
;Out:AIX= 
KosAIX
	 CP #FF
	 JR NZ,KosAIX0	 ; 
   ; #FF,  
	 LD A,(PageN)
KosAIX0
	 LD B,xh
	 BIT 7,B
	 RET NZ
	 BIT 6,B
	 RET NZ
	 PUSH AF
   ;  
	 LD A,B
	 OR #C0
	 LD xh,A
	 POP AF
	 CALL Page
	 PUSH HL
	 LD A,(IX)
	 LD L,(IX+1)
	 LD H,(IX+2)
	 PUSH HL
	 POP HL
	 POP HL
	 JR KosAIX
