unit strlist;
{  ࠡ⪨ ᪨ ᯨ᪮ ப}
interface
type
 TStringP=^TStringPV;
 TStringPV=record
        Value:string;
        Next,Prev:TStringP;
           end;
  TStringList=object
   private
    beglist,endlist:TStringP;
    strcount:word;
   public
    SectionName:string;
     {  ६ ࠭   ᥪ樨,   ᫥ ࠧ
       㦠 ⮤ LoadSection}
    constructor Init;
    destructor Done;
    function Count:word;
    procedure Add(Ln:string);
    function Line(Index:word):string;
    procedure Delete(Index:word);
    procedure LoadFromFile(FName:string);
    procedure SaveToFile(FName:string);
    function LoadSection(FName,Section:string):boolean;
     {㧪 ᥪ樨 ᠭ  .}
    procedure MergeFile(FName:string);
    procedure Clear;
    function FindLine(Ln:string; var Index:word):boolean;
     { ப Ln  ᯨ᪥, ᫨  - True}
    procedure ReplaceStr(Ln:string; Index:word);
     { ப  ᮬ Index  ப Ln}
   end;
 function CompareLists(List1,List2:TStringList):boolean;
 procedure CopyLists(var List1,List2:TStringList);
implementation
uses dos;
function CutSectionName(Ln:string):string;
{ १ ப  xxxx(yy...)  ப xxxx}
var
 i:word;
 tmp:string;
begin
 tmp:='';
 for i:=1 to Length(Ln) do
  if Ln[i]='(' then
   begin
    CutSectionName:=tmp;
    Exit;
   end else tmp:=tmp+Ln[i];
 CutSectionName:=tmp;
end;

procedure CopyLists(var List1,List2:TStringList);
var
 cnt:word;
begin
 List1.Clear;
 for cnt:=0 to List2.Count-1 do List1.Add(List2.Line(cnt));
end;

function CompareLists(List1,List2:TStringList):boolean;
var
 cnt:word;
begin
 CompareLists:=false;
 if List1.Count<>List2.Count then Exit;
 for cnt:=0 to List1.Count-1 do
  if List1.Line(cnt)<>List2.Line(cnt) then Exit;
 CompareLists:=true;
end;

procedure AssignList(var List1,List2:TStringList);
begin
 List1.Clear; {   窨  }
 List1.beglist:=List2.beglist;
 List1.endlist:=List2.endlist;
 List1.strcount:=List2.strcount;
end;

constructor TStringList.Init;
begin
 beglist:=nil;
 endlist:=nil;
 strcount:=0;
end;

destructor TStringList.Done;
var
 tmp:TStringP;
begin
 if strcount=0 then Exit;
 while beglist^.Next<>nil do
  begin
   tmp:=beglist^.Next;
   Dispose(beglist);
   beglist:=tmp;
  end;
 Dispose(beglist);
end;

function TStringList.Count:word;
begin
 Count:=strcount;
end;

procedure TStringList.Add(Ln:string);
var
 tmp:TStringP;
begin
 New(tmp);
 tmp^.Value:=Ln;
 tmp^.Next:=nil;
 tmp^.Prev:=endlist;
 if endlist<>nil then endlist^.Next:=tmp;
 if beglist=nil then beglist:=tmp;
 endlist:=tmp;
 Inc(strcount,1);
end;

function TStringList.Line(Index:word):string;
var
 i:word;
 tmp:TStringP;
begin
 if Index>strcount-1 then
  begin
   Line:='';
   Exit;
  end;
 i:=0;
 tmp:=beglist;
 while i<>Index do
  begin
   tmp:=tmp^.Next;
   Inc(i,1);
  end;
 Line:=tmp^.Value;
end;

procedure TStringList.Delete(Index:word);
var
 tmp,tmp1,tmp2:TStringP;
 i:word;
begin
 if Index>strcount-1 then Exit;
 if Index=0 then
  begin
   tmp:=beglist^.Next;
   Dispose(beglist);
   Dec(strcount,1);
   beglist:=tmp;
   Exit;
  end;
 if Index=strcount-1 then
  begin
   tmp:=endlist^.Prev;
   Dispose(endlist);
   endlist:=tmp;
   endlist^.Next:=nil;
   Dec(strcount,1);
   Exit;
  end;
 i:=0;
 tmp:=beglist;
 while i<>Index do
  begin
   tmp:=tmp^.Next;
   Inc(i,1);
  end;
 tmp1:=tmp^.Prev;
 tmp2:=tmp^.Next;
 tmp2^.Prev:=tmp1;
 tmp1^.Next:=tmp2;
 Dispose(tmp);
 Dec(strcount,1);
end;

procedure TStringList.LoadFromFile(FName:string);
var
 f:Text;
 tmp:string;
begin
 assign(f,FName);
 reset(f);
 while not eof(f) do
  begin
   readln(f,tmp);
   Add(tmp);
  end;
 Close(f);
end;

procedure TStringList.SaveToFile(FName:string);
var
 f:Text;
 tmp:TStringP;
begin
 if beglist=nil then exit;
 Assign(f,FName);
 rewrite(f);
 tmp:=beglist;
 while tmp<>nil do
  begin
   writeln(f,tmp^.Value);
   tmp:=tmp^.Next;
  end;
 Close(f);
end;

function TStringList.LoadSection(FName,Section:string):boolean;
var
 f:Text;
 tmp:string;
 sect:boolean;
begin
 sect:=false;
 assign(f,FName);
 reset(f);
 while not eof(f) do
  begin
   readln(f,tmp);
   if not sect then
    begin
     SectionName:=tmp;
     tmp:=CutSectionName(tmp);
    end;
   if tmp=Section then
    begin
     sect:=true;
     readln(f,tmp);
    end;
   if (tmp='.') and Sect then
    begin
     LoadSection:=true;
     close(f);
     exit;
    end;
   if sect then Add(tmp);
  end;
 LoadSection:=false;
 close(f);
end;

procedure TStringList.Clear;
var
 tmp:TStringP;
begin
 if strcount=0 then Exit;
 while beglist^.Next<>nil do
  begin
   tmp:=beglist^.Next;
   Dispose(beglist);
   beglist:=tmp;
  end;
 Dispose(beglist);
 beglist:=nil;
 endlist:=nil;
 strcount:=0;
end;

procedure TStringList.MergeFile(FName:string);
var
 f:Text;
 tmp:string;
begin
 assign(f,FName);
 {$I-}
 reset(f);
 {$I+}
 if IOResult<>0 then
  begin
   WriteLn('file not found:',FName);
   Halt(1);
  end;
 while not eof(f) do
  begin
   readln(f,tmp);
   add(tmp);
  end;
 close(f);
end;

function TStringList.FindLine(Ln:string; var Index:word):boolean;
var
 i:integer;
 tmp:TStringP;
begin
 i:=0;
 FindLine:=false;
 if strcount=0 then Exit;
 tmp:=beglist;
 while tmp^.Next<>nil do
  begin
   if tmp^.Value=Ln then
    begin
     FindLine:=true;
     Index:=i;
     Exit;
    end;
   tmp:=tmp^.Next;
   Inc(i,1);
  end;
end;

procedure TStringList.ReplaceStr(Ln:string; Index:word);
var
 i:word;
 tmp:TStringP;
begin
 if Index>strcount-1 then Exit;
 i:=0;
 tmp:=beglist;
 while i<>Index do
  begin
   tmp:=tmp^.Next;
   Inc(i,1);
  end;
 tmp^.Value:=Ln;
end;

end.
